/**
 * OW2 Util
 * Copyright (C) 2012 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: ForwardingScriptEngineFactory.java 6240 2012-04-18 11:03:10Z sauthieg $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.plan.deployer.impl.condition.script;

import java.util.List;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineFactory;

/**
 * A {@code ForwardingScriptEngineFactory} is ...
 *
 * @author Guillaume Sauthier
 */
public abstract class ForwardingScriptEngineFactory implements ScriptEngineFactory {

    protected abstract ScriptEngineFactory delegate();

    public String getEngineName() {
        return delegate().getEngineName();
    }

    public String getEngineVersion() {
        return delegate().getEngineVersion();
    }

    public List<String> getExtensions() {
        return delegate().getExtensions();
    }

    public List<String> getMimeTypes() {
        return delegate().getMimeTypes();
    }

    public List<String> getNames() {
        return delegate().getNames();
    }

    public String getLanguageName() {
        return delegate().getLanguageName();
    }

    public String getLanguageVersion() {
        return delegate().getLanguageVersion();
    }

    public Object getParameter(String key) {
        return delegate().getParameter(key);
    }

    public String getMethodCallSyntax(String obj, String m, String... args) {
        return delegate().getMethodCallSyntax(obj, m, args);
    }

    public String getOutputStatement(String toDisplay) {
        return delegate().getOutputStatement(toDisplay);
    }

    public String getProgram(String... statements) {
        return delegate().getProgram(statements);
    }

    public ScriptEngine getScriptEngine() {
        return delegate().getScriptEngine();
    }
}
